<?php
require_once('simple_html_dom.php');

function loadData() {
    $lData = file_get_contents('data.txt');
    return $lData;
}

function parseData() {
    $lData = loadData();
    $lReturnData = array();
    
    $html = str_get_html($lData);
    $counter = 0;
    $startdate = time();
    $deltaday = 0;
    $prevtime = 0;
    foreach($html->find('table[id="TBL1"] tr') as $row) {
        if ($counter == 0) {
            $counter2 = 0;
            foreach($row->find('th') as $head){
                $lReturnData[$counter2]['name'] = trim($head->text());
                $lReturnData[$counter2]['icon'] = 'leeg';
                $counter2++;
            }
        } else {
            $counter2 = 0;
            foreach($row->find('td') as $cell){
                foreach($cell->find('div[class="event"]') as $div) {
                    if ($div != null) {
                        $title = $div->find('div[class="title"]',0);
                        if ($title != null) $title = trim($title->text());
                        $desc = $div->find('div[class="desc"]',0);
                        if ($desc != null) $desc = trim($desc->text());
                        $time = $div->find('div',0);
                        if ($time != null) {
                            $time = explode(':',trim($time->text()));
                            $time = mktime($time[0],$time[1],0,date('n',$startdate),date('j',$startdate),date('Y',$startdate));
                        }
                        $lReturnData[$counter2]['programs'][] = array('start' => $time, 'end' => 0, 'title' => $title, 'description' => $desc);
                    }
                }
                $counter2++;
            }
        }
        $counter++;
    }
    
    // Fixing the program dates....
    for ($counter1 = 0; $counter1 < count($lReturnData); $counter1++) {
      $today = time();
      $laststart = 0;
      $deltaday = 0;
      for ($counter2 = 0 ; $counter2 < count($lReturnData[$counter1]['programs']); $counter2++) {
        $programstart = $lReturnData[$counter1]['programs'][$counter2]['start'];
        $programstart = mktime(date('H',$programstart),date('i',$programstart),0,date('n',$today),date('j',$today),date('Y',$today));
        $programstart += ($deltaday * 24 * 3600);
        
        if ($laststart > $programstart) {
          $deltaday++;
          $programstart += ($deltaday * 24 * 3600);
        }
        
        $laststart = $programstart;
        
        $lReturnData[$counter1]['programs'][$counter2]['start'] = $programstart;
        if ($counter2 > 0) {
          $lReturnData[$counter1]['programs'][$counter2-1]['end'] = $programstart;
        }
      }
    }
    
    return $lReturnData;
}
?>

<html>
<head>
    <script type="text/javascript" src="//code.jquery.com/jquery-1.10.2.min.js"></script>
    <style>
      .all {
        width: 100%;
        white-space: nowrap;
        overflow-x: hidden;
        overflow-y: scroll;
        line-height: 25px;
        font-size: 20px;
        height: 90%;
      }
       .channels {
         float: left;
         width: 200px;
         overflow: hidden;
         box-shadow: 5px 0px 15px 5px black;
         border-right: solid 1px black;
       }
       .name {
            float: left;
            /*border: solid 1px green;*/
            background-color: rgb(174,191,230);
            width: 100%;
            font-weight: bold;
            line-height: 50px;
            height: 50px;
            border-bottom: solid 1px black;
       }
       .programs {
        /*min-width: 200%;*/
       }
       .window {
         overflow-x: scroll;
       }
       
       .devider {
         width: 500%;
         height: 50px;
         float: left;
         border-bottom: solid 1px black;
         
       }
       .program {
            border-left: solid 1px blue;
            display: block;
            float: left;
            overflow:hidden;
            font-size: 10px;
            margin-right: -1px;
       }
    </style>
</head>
<body>
<?php
$ldata = parseData();
$labels = '';
$programs = '';

foreach($ldata as $channel) {
  $labels .= "<label class='name'>" . $channel['name'] . '</label>';
  $programs .= '<div class="devider">';
  $firstprogram = true;
  foreach ($channel['programs'] as $program) {
    if ($program['end'] != 0 && $program['end'] < time()) continue;
    $factor = 10;
    $width = ($program['end'] - $program['start']) / $factor;
    if ($firstprogram) {
      $width -= (time() - $program['start']) / $factor;
    }
    if ($program['end'] == 0) {
      $width = 30 * 60 / $factor;
    }
    $programs .= '<div class="program" title="' .date('d-m-Y H:i:s',$program['start']) . ' ' . $program['title'] .  '" style="width:' . $width . 'px;">' . date('d-m-Y H:i:s',$program['start']) . '<br />' . $program['title'] . '</div>';
      $firstprogram = false;
    }
  $programs .= '</div>';
  $counter++;
}

echo "<div class='all'>";
echo "<div class='channels'>" . $labels . "</div>";
echo "<div class='window'><div class='programs'>" . $programs . "</div></div>";
echo "</div>";
?>

<script type="text/javascript">
jQuery(document).ready(function() {
  var maxWidth = 0;
  jQuery('.devider').each(function() {
    var width = 200;
    jQuery(this).find('div').each(function() {
      width += jQuery(this).width();
    });
    if (width > maxWidth) {
      maxWidth = width;
    }
  })
  jQuery('.devider').css('width',maxWidth);
});
</script>
</body>
</html>